



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PHP多线程的实现（PHP多线程类）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PHP多线程的实现（PHP多线程类）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 17:50:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>通过WEB服务器来实现PHP多线程功能。</p>
<p>当然，对多线程有深入理解的人都知道通过WEB服务器实现的多线程只能模仿多线程的一些效果，并不是真正意义上的多线程。</p>
<p>但不管怎么样，它还是能满足我们的一些需要的，在需要类似多线程的功能方面还是可以采用这个类。</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * @title:        PHP多线程类(Thread)<br />
 * @version:    1.0<br />
 * @author:        phper.org.cn &lt; web@phper.org.cn &gt;<br />
 * @published:    2010-11-2<br />
 *<br />
 * PHP多线程应用示例：<br />
 *  require_once 'thread.class.php';<br />
 *  $thread = new thread();<br />
 *  $thread-&gt;addthread('action_log','a');<br />
 *  $thread-&gt;addthread('action_log','b');<br />
 *  $thread-&gt;addthread('action_log','c');<br />
 *  $thread-&gt;runthread();<br />
 *<br />
 *  function action_log($info) {<br />
 *      $log = 'log/' . microtime() . '.log';<br />
 *      $txt = $info . "\r\n\r\n" . 'Set in ' . Date('h:i:s', time()) . (double)microtime() . "\r\n";<br />
 *      $fp = fopen($log, 'w');<br />
 *      fwrite($fp, $txt);<br />
 *      fclose($fp);<br />
 *  }<br />
 */<br />
class thread {

    var $hooks = array();<br />
    var $args = array();

    function thread() {<br />
    }

    function addthread($func)<br />
    {<br />
        $args = array_slice(func_get_args(), 1);<br />
        $this-&gt;hooks[] = $func;<br />
        $this-&gt;args[] = $args;<br />
        return true;<br />
    }

    function runthread()<br />
    {<br />
        if(isset($_GET['flag']))<br />
        {<br />
            $flag = intval($_GET['flag']);<br />
        }<br />
        if($flag || $flag === 0)<br />
        {<br />
            call_user_func_array($this-&gt;hooks[$flag], $this-&gt;args[$flag]);<br />
        }<br />
        else<br />
        {<br />
            for($i = 0, $size = count($this-&gt;hooks); $i &lt; $size; $i++)<br />
            {<br />
                $fp=fsockopen($_SERVER['HTTP_HOST'],$_SERVER['SERVER_PORT']);<br />
                if($fp)<br />
                {<br />
                    $out = "GET {$_SERVER['PHP_SELF']}?flag=$i HTTP/1.1\r\n";<br />
                    $out .= "Host: {$_SERVER['HTTP_HOST']}\r\n";<br />
                    $out .= "Connection: Close\r\n\r\n";<br />
                    fputs($fp,$out);<br />
                    fclose($fp);<br />
                }<br />
            }<br />
        }<br />
    }<br />
}</pre>
</div>
<p><strong>使用方法：</strong></p>
<p>$thread = new thread(); $thread-&gt;addthread('func1','info1'); $thread-&gt;addthread('func2','info2'); $thread-&gt;addthread('func3','info3'); $thread-&gt;runthread();</p>
<p><strong>说明：</strong></p>
<p>addthread是添加线程函数，第一个参数是函数名，之后的参数（可选）为传递给指定函数的参数。</p>
<p>runthread是执行线程的函数。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7lze8e.html">Dropzone&period;js实现文件拖拽上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8ml6d69.html">https基础流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8er57mq.html">微信支付v3发布到iis时的证书问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0oo0q.html">安装完MySQL数据库，在服务列表里找不到MySQL的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvm07xq.html">Windows下搭建Git开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq13mz48.html">SRS文档  王倩倩  201303014004</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmo1kk9.html">ios  kvo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1w1zx8.html">liux下ftp链接服务器的常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn4ogz8.html">SQL Server I&sol;O 问题的诊断分</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvmp2zq.html">diy 电脑 重装系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok0zpe9.html">java&lowbar;reflect&lowbar;01</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7jdoq.html">柯南君：看大数据时代下的IT架构（9）消息队列之RabbitMQ--案例（RPC起航）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k5p659.html">php curl 获取 HTTPS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy105ljq.html">SAP开发快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdolyv9.html">ps&colon; 图层样式；</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r53l7rq.html">eclipse自动生成变量名声明&lpar;按方法返回值为本地变量赋值）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j1gm5q.html">说说自己对RESTful API的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv1252q.html">使用cat读取和echo写内核文件节点的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2lkpe8.html">php查找之二分查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv0e32q.html">移动端 H5 弹出层 fixed 内容可滚动</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwd6l0k8.html">修改ORACLE-NLS&lowbar;DATE&lowbar;FORMAT时间格式的四种方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1dmoj9.html">ORACLE数据库存储结构简介（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gml4n79.html">GitBook是一个命令行工具（Node&period;js库），我们可以借用该工具使用Github&sol;Git和Markdown来制作精美的图书，但它并不是一本关于Git的教程哟。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydprzxq.html">Permutations&comma;Permutations II&comma;Combinations</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zel269.html">本地网址连不上远程mysql问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zelez9.html">ajax&period;request函数使用详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yxd70q.html">【原】YUI3：js加载过程及时序问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdemk379.html">用apiCloud开发应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o1znn9.html">opencv如何截取子图像</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0kx2gq.html">Invalidate&lpar;TRUE&rpar;与Invalidate&lpar;FALSE&rpar;区别（前者会发送WM&lowbar;ERASEBKGND消息全部刷新，然后使用WM&lowbar;PAINT消息绘制，而后者只发送WM&lowbar;PAINT消息）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
